"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateModuleMap = generateModuleMap;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _path = require("path");

var _fsExtra = require("fs-extra");

var _server = require("react-cosmos-shared2/server");

// TODO: Make fixturesDir configurable
// See: https://github.com/react-cosmos/react-cosmos/issues/488
var FIXTURES_DIR = '__jsxfixtures__';

function generateModuleMap(_x) {
  return _generateModuleMap.apply(this, arguments);
}

function _generateModuleMap() {
  _generateModuleMap = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(_ref) {
    var rootDir, _ref5, fixtures, decorators, modules, modulesPath, relModulesPath;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            rootDir = _ref.rootDir;
            _context.next = 3;
            return (0, _server.findFiles)({
              rootDir: rootDir,
              fixturesDir: FIXTURES_DIR
            });

          case 3:
            _ref5 = _context.sent;
            fixtures = _ref5.fixtures;
            decorators = _ref5.decorators;
            modules = template({
              fixtures: genRequiresForPaths({
                paths: fixtures,
                rootDir: rootDir
              }),
              decorators: genRequiresForPaths({
                paths: decorators,
                rootDir: rootDir
              })
            });
            modulesPath = (0, _path.join)(rootDir, 'cosmos.modules.js');
            _context.next = 10;
            return (0, _fsExtra.writeFile)(modulesPath, modules, 'utf8');

          case 10:
            relModulesPath = (0, _path.relative)(process.cwd(), modulesPath);
            console.log("[Cosmos] Generated ".concat(relModulesPath));

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _generateModuleMap.apply(this, arguments);
}

function genRequiresForPaths(_ref2) {
  var paths = _ref2.paths,
      rootDir = _ref2.rootDir;
  var entries = paths.map(function (path) {
    return generateRequireForPath({
      path: path,
      rootDir: rootDir
    });
  });
  return "{".concat(entries.join(","), "}");
}

function generateRequireForPath(_ref3) {
  var path = _ref3.path,
      rootDir = _ref3.rootDir;
  var relPath = (0, _path.relative)(rootDir, path); // TODO: Full path must also be provided so the client can open file on command

  var cleanPath = relPath.replace(new RegExp("".concat(FIXTURES_DIR, "/"), 'g'), ''); // TODO: Can require path be relative too?

  return "'".concat(cleanPath, "': require('./").concat(relPath, "')");
}

function template(_ref4) {
  var fixtures = _ref4.fixtures,
      decorators = _ref4.decorators;
  return "// This file is automatically generated by Cosmos. Best ignore it.\n\nexport const fixtures = ".concat(fixtures, ";\nexport const decorators = ").concat(decorators, ";\n");
}