"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateModulesFile = generateModulesFile;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _path = require("path");

var _fsExtra = require("fs-extra");

var _server = require("react-cosmos-shared2/server");

function generateModulesFile(_x) {
  return _generateModulesFile.apply(this, arguments);
}

function _generateModulesFile() {
  _generateModulesFile = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(rootPath) {
    var modulesPath, modulesImports, relModulesPath;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            modulesPath = (0, _path.join)(rootPath, 'cosmos.modules.js');
            _context.next = 3;
            return generateModuleImports(rootPath);

          case 3:
            modulesImports = _context.sent;
            _context.next = 6;
            return (0, _fsExtra.writeFile)(modulesPath, modulesImports, 'utf8');

          case 6:
            relModulesPath = (0, _path.relative)(process.cwd(), modulesPath);
            console.log("[Cosmos] Generated ".concat(relModulesPath));

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _generateModulesFile.apply(this, arguments);
}

function generateModuleImports(_x2) {
  return _generateModuleImports.apply(this, arguments);
}

function _generateModuleImports() {
  _generateModuleImports = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(rootPath) {
    var _ref4, fixtures, decorators;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _server.findFiles)({
              cwd: rootPath
            });

          case 2:
            _ref4 = _context2.sent;
            fixtures = _ref4.fixtures;
            decorators = _ref4.decorators;
            return _context2.abrupt("return", template({
              fixtures: genRequiresForPaths({
                paths: fixtures,
                rootPath: rootPath
              }),
              decorators: genRequiresForPaths({
                paths: decorators,
                rootPath: rootPath
              })
            }));

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _generateModuleImports.apply(this, arguments);
}

function genRequiresForPaths(_ref) {
  var paths = _ref.paths,
      rootPath = _ref.rootPath;
  var entries = paths.map(function (path) {
    return generateRequireForPath({
      path: path,
      rootPath: rootPath
    });
  });
  return "{".concat(entries.join(","), "}");
}

function generateRequireForPath(_ref2) {
  var path = _ref2.path,
      rootPath = _ref2.rootPath;
  // TODO: Remove __jsxfixtures__ from relative path
  // Relevant: https://github.com/react-cosmos/react-cosmos/issues/488
  var relPath = (0, _path.relative)(rootPath, path); // TODO: Can require path be relative too?

  return "'".concat(relPath, "': require('").concat(relPath, "')");
}

function template(_ref3) {
  var fixtures = _ref3.fixtures,
      decorators = _ref3.decorators;
  return "// This file is automatically generated by Cosmos. Best ignore it.\n\nexport const fixtures = ".concat(fixtures, ";\nexport const decorators = ").concat(decorators, ";\n");
}